# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []

def install():
    print('installing %s' % control.asrequirement())

    if service_installed('ssh-agent'):
        if service_is_running('ssh-agent'):
            service_stop('ssh-agent')
        run('sc delete ssh-agent')

    if service_installed('sshd'):
        if service_is_running('sshd'):
            service_stop('sshd')
        run('sc delete sshd')

    if isdir(makepath(programfiles32,'OpenSSH')):
        remove_tree(makepath(programfiles32,'OpenSSH'))
    copytree2('OpenSSH',makepath(programfiles32,'OpenSSH'))

    with disable_file_system_redirection():
        run('sc.exe create ssh-agent binPath= "%s" start= auto' % makepath(programfiles32,'OpenSSH','ssh-agent.exe'))
        run('sc.exe create sshd binPath= "%s" start= auto' % makepath(programfiles32,'OpenSSH','sshd.exe'))
        run('sc.exe sdset ssh-agent D:(A;;CCLCSWRPWPDTLOCRRC;;;SY)(A;;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;BA)(A;;CCLCSWLOCRRC;;;IU)(A;;CCLCSWLOCRRC;;;SU)(A;;RP;;;AU)')



    service_start('ssh-agent')
    service_start('sshd')

    if windows_version() > Version('5.2'):
        run_notfatal('netsh advfirewall firewall delete rule "sshd"')
        run('netsh advfirewall firewall add rule name=sshd action=allow localport=22 protocol=tcp dir=in')

def uninstall():
    if service_installed('ssh-agent'):
        if service_is_running('ssh-agent'):
            service_stop('ssh-agent')
        run('sc delete ssh-agent')

    if service_installed('sshd'):
        if service_is_running('sshd'):
            service_stop('sshd')
        run('sc delete sshd')

    if isdir(makepath(programfiles32,'OpenSSH')):
        remove_tree(makepath(programfiles32,'OpenSSH'))
    copytree2('OpenSSH',makepath(programfiles32,'OpenSSH'))

    run_notfatal('netsh advfirewall firewall delete rule "sshd"')



